-- This script is copyright tadstools.co.uk tads421 Please do not use this script in any other scripts or  modify without consent.
rollout createbox "Create Nodes "
(
	edittext nodename1 "Node Name:" pos:[15,05] fieldWidth:100 labelOnTop:false
	spinner nodex1 "X" pos:[20,35] width:100 height:20 range:[-1000000,1000000,0.00]
	spinner nodey1 "Y" pos:[20,65] width:100 height:20 range:[-1000000,1000000,0.00]
	spinner nodez1 "Z" pos:[20,95] width:100 height:20 range:[-1000000,1000000,0.00]
	button create_node "create Node" pos:[145,85] height:30

	on create_node Pressed do
	(
	mynodex1 = nodex1.value
	mynodey1 = nodey1.value
	mynodez1 = nodez1.value
		mynode= Dummy pos:[mynodex1,mynodey1,mynodez1]  boxsize:[0.05, 0.05,0.05]	
		mynode.name = nodename1.text
	)
)
rollout jbeam "Jbeam Settings & Export"
(
	edittext File_Name "File Name:" fieldWidth:100 labelOnTop:false
	spinner nodeWeight "node Weight:" range:[-100.0,100,0.4] fieldwidth:40 align:#left 
	label labhr1 "___________________________________"
	spinner frictionCoef "friction Coef:" range:[-100.0,100,0.7] fieldwidth:40 align:#left
	label labhr2 "___________________________________"
	edittext grouptxt "group:" fieldWidth:100 labelOnTop:false
	label labhr3 "___________________________________"
	dropdownlist nodeMaterial "node Material" items:#("|NM_METAL", "|NM_PLASTIC")  
	dropdownlist node_collision "collision"  items:#("true","false") 
	dropdownlist selfCollision "self Collision" items:#("true","false") 
    label lab12 ""
	label lab6 "select the objects to export data for. \n"
	label lab5 ""
	
		button btn_print "Export selected Node Data CFG File" height:30
		label lab7 ""
		label lab8 ""	
	on btn_print Pressed do
	(
		selectedobj =	selection
		thePath = getSavepath()
		strmtxt = File_Name.text
		strmnodeweight = nodeWeight.value
		strmgroup = grouptxt.text
		strmfrictionCoef = frictionCoef.value
		strmnodeMaterial = nodeMaterial.text
		strmnode_collision = node_collision.text
		strmselfCollision = selfCollision.text		
		filepath = thepath + "/" + strmtxt + ".cfg"
		
		   if doesFileExist filepath ==false then 
		   (
			   crfile = createfile filepath
		   close crfile
		   )
		   emptystring = "your meshes/n/n"
		   	strm = openfile filepath Mode:"w"
		   (
		   )
		   format "\"nodes\" : [\n" to:strm
		    format "[\"id\", \"posX\", \"posY\", \"posZ\"],\n" to:strm
		   format "[\"0\", \"1\", \"2\", \"3\"]\n" to:strm
		   format "{\"nodeWeight\":%},\n" strmnodeweight to:strm
		   format "{\"group\":\"%\"},\n" strmgroup to:strm
		   format "{\"frictionCoef\":%},\n" strmfrictionCoef to:strm
		   format "{\"nodeMaterial\":\"%\"},\n" strmnodeMaterial to:strm
		  format "{\"collision\":%},\n" strmnode_collision to:strm
		  format "{\"collision\":%},\n" strmselfCollision to:strm
		   format "//BNEG:Node Data from Node_data_tool tads421 \n" to:strm
		for o in selection do
		(
			nodename = o.name
			nodeposx = formattedprint o.pos.x format:".2f"
			nodeposy = formattedprint o.pos.y format:".2f"
			nodeposz = formattedprint o.pos.z format:".2f"
			format "[\"%\", %,%,%],\n" nodename nodeposx nodeposy nodeposz to:strm
		)
		format "]," to:strm
		close strm
		messagebox "Nodes Exported saved"
	)
)

rollout aboutus "About US"
(
	label lab1 "Thank you for using this tool."
	label lab2 "BeamNG Node Data CFG export tool."
	label lab3 "Export to where you need"
	label lab4 "and use the node tool."
	label lab5 "www.tadstools.co.uk"
)

    nf = newRolloutFloater "BeamNG Node Tool." 250 710
    addrollout createbox nf
    addrollout jbeam nf
	addrollout aboutus nf